//
//  BSHotKey.h
//  GameTest
//
//  Created by Karsten Kusche on 08.11.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//
#ifndef __HOTKEY_H_KK__
#define __HOTKEY_H_KK__

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>
//#import "CGSHotKeys.h"

/*
 
 This class represents a hotkey. 
 a hotkey can be registered, unregistered, printed and stored

*/

@interface BSHotKey : NSObject {
	NSUInteger keyCode;   // number of keyboard key
	NSUInteger modifiers;// modifiers
	EventHotKeyRef hotKeyRef; // reference used to identify the hotkey
	NSString* name;
}

// instance creation
+ (id)hotKeyFromArray:(NSArray*)array;
+ (id)escapeHotKey;
+ (unichar)keyCodeToCharacter:(UInt16)key;

+ (id)hotKeyWithSystemHotKey:(uint32_t)hotKeyID additionalCocoaModifiers:(NSUInteger)moreModifiers;
+ (id)hotKeyWithKey:(unsigned char)key cocoaModifiers: (NSUInteger)modifiers;
+ (id)hotKeyWithKey:(unsigned char)key modifiers: (NSUInteger)modifiers;
// To use hotKeyWithKey:modifiers: please run the test app that is included 
// in the BSHotKey distribution. it will show which values to use as soon as the  hotkey is set


// [un]register a hotkey
- (EventHotKeyRef)setWithID:(NSUInteger)anID;
- (void)unRegister;
- (BOOL)isRegistered;
// conversion and comparing
- (NSArray*) asArray;
- (BOOL)isSet;
- (NSString*)name;
- (void)setName:(NSString*)aName;

- (void)setFromArray:(NSArray *)hotkeyArray;
- (void)setFromNSEvent:(NSEvent*)theEvent;
- (void)save;

- (BOOL)isAlreadyInUse;
- (BOOL)isValid;
- (BOOL)isDelete;
- (BOOL)isEscape;
- (NSString*)errorMessage;
- (NSString*)keyDescription;
- (NSString*)keyEquivalent;
- (NSInteger)keyEquivalentModifierMask;

@end

#endif
